summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-11-28 12:28:03 -0300
committerGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-11-28 12:28:03 -0300
commit8eb4c624dc41f47f93a04d9e42f531e0642e228b (patch)
tree6e2acec694aec8acca21a86aa5f12df1bc673b1a
parent1edaf15cef3420484d1dfbf08de43fe8d800ab64 (diff)
[archiso] Add archiso_pxe_curl hook
Its add support for downloading the ISO image via HTTP/FTP with curl or download *.sfs files. The files are downloaded on /run/archiso/curlspace (tmpfs) and setup a loop dev from it (like in archiso_loop_mnt) in the ISO case, or just do a bind mount to /run/archiso/bootmnt in the other case. This hook must be located after archiso_pxe_nbd in mkinitcpio.conf, in that way NBD is the default. New bootparm: * archiso_curl_url=(first form) archiso_curl_url=http://192.168.0.7/archlinux/iso/archlinux.iso (absolute form) Use an absolute URL. Fetch the entire ISO archiso_curl_url=ftp://${pxeserver}/archlinux/iso/archlinux.iso (relative form) Use the as IP the same server where PXE reside. Fetch the entire ISO * archiso_curl_url=(second form) archiso_curl_url=http://192.168.0.7/archlinux/iso/unpacked (absolute form) Use an absolute URL. Where unpacked (an example name) is a directory where ${archisobasedir} ("arch" by default) is located with all *.sfs. This fetch only needed files. archiso_curl_url=ftp://${pxeserver}/archlinux/iso/unpacked (relative form) Use the as IP the same server where PXE reside. Where unpacked (an example name) is a directory where ${archisobasedir} ("arch" by default) is located with all *.sfs. This fetch only needed files. * curlspace_size= Set a size for a tmpfs filesystem where files are downloaded. Signed-off-by: Gerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>
-rw-r--r--README15
-rw-r--r--archiso/Makefile4
-rw-r--r--archiso/hooks/archiso_pxe_curl75
-rw-r--r--archiso/install/archiso_pxe_curl18
-rwxr-xr-xconfigs/releng/build.sh4
-rw-r--r--configs/releng/mkinitcpio.conf2
-rw-r--r--configs/releng/packages.i6861
-rw-r--r--configs/releng/packages.x86_641
8 files changed, 115 insertions, 5 deletions
diff --git a/README b/README
index 0dd2179..dede082 100644
--- a/README
+++ b/README
@@ -74,6 +74,7 @@ INDEX
BOOTIF=<hardware-address-of-boot-interface>
Default: (set via PXELINUX)
+
** hooks/archiso_pxe_nbd
* archiso_nbd_name= Set NBD export name used by the server.
@@ -82,6 +83,18 @@ INDEX
Default: "${pxeserver}" (The <boot-server-ip from ip=)
+** hooks/archiso_pxe_curl
+
+* archiso_curl_url= Set an HTTP/FTP URL of an ISO file (first form),
+ or a path (must end with /) where ${archisobasedir}
+ is found with all *.sfs files (second form).
+ In the IP part if ${pxeserver} is used, PXE IP will be used.
+ Default: (unset)
+* curlspace_size= Set the size of tmpfs of "curlspace" where the specified
+ ISO image or *.sfs files are downloaded.
+ Default: "75%"
+
+
** hooks/archiso_loop_mnt
* img_label= Set the filesystem label where archiso-image.iso.
@@ -127,6 +140,8 @@ if nothing is specified on command line.
+ mkinitcpio-nfs-utils for ipconfig
* archiso_pxe_nbd
+ nbd for nbd-client
+* archiso_pxe_curl
+ + curl for curl
* archiso_shutdown
+ (none)
diff --git a/archiso/Makefile b/archiso/Makefile
index 115a15b..0dbbbf8 100644
--- a/archiso/Makefile
+++ b/archiso/Makefile
@@ -20,6 +20,8 @@ install-hooks:
install -D -m 644 install/archiso_pxe_common $(DESTDIR)/lib/initcpio/install/archiso_pxe_common
install -D -m 644 hooks/archiso_pxe_nbd $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_nbd
install -D -m 644 install/archiso_pxe_nbd $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
+ install -D -m 644 hooks/archiso_pxe_curl $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_curl
+ install -D -m 644 install/archiso_pxe_curl $(DESTDIR)/lib/initcpio/install/archiso_pxe_curl
install -D -m 644 hooks/archiso_loop_mnt $(DESTDIR)/lib/initcpio/hooks/archiso_loop_mnt
install -D -m 644 install/archiso_loop_mnt $(DESTDIR)/lib/initcpio/install/archiso_loop_mnt
@@ -45,6 +47,8 @@ uninstall:
rm -f $(DESTDIR)/lib/initcpio/install/archiso_pxe_common
rm -f $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_nbd
rm -f $(DESTDIR)/lib/initcpio/install/archiso_pxe_nbd
+ rm -f $(DESTDIR)/lib/initcpio/hooks/archiso_pxe_curl
+ rm -f $(DESTDIR)/lib/initcpio/install/archiso_pxe_curl
rm -f $(DESTDIR)/lib/initcpio/hooks/archiso_loop_mnt
rm -f $(DESTDIR)/lib/initcpio/install/archiso_loop_mnt
rm -rf $(DESTDIR)/usr/share/archiso/
diff --git a/archiso/hooks/archiso_pxe_curl b/archiso/hooks/archiso_pxe_curl
new file mode 100644
index 0000000..7a553ad
--- /dev/null
+++ b/archiso/hooks/archiso_pxe_curl
@@ -0,0 +1,75 @@
+# vim: set ft=sh:
+
+run_hook() {
+ if [[ -n "${ip}" && -n "${archiso_curl_url}" ]]; then
+ archiso_curl_url=$(eval echo ${archiso_curl_url})
+ [[ -z "${curlspace_size}" ]] && curlspace_size="75%"
+ mount_handler="archiso_pxe_curl_mount_handler"
+ fi
+}
+
+# Fetch a file with CURL
+#
+# $1 URL
+# $2 Destination directory inside curlspace
+_curl_get() {
+ local _url="${1}"
+ local _dst="${2}"
+
+ msg ":: Downloading '${_url}'"
+ if ! curl -f -o "/run/archiso/curlspace/${_dst}/${_url##*/}" --create-dirs "${_url}"; then
+ echo "ERROR: Downloading '${_url}'"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
+ fi
+}
+
+archiso_pxe_curl_mount_handler () {
+ newroot="${1}"
+
+ msg ":: Mounting /run/archiso/curlspace (tmpfs) filesystem, size='${curlspace_size}'"
+ mkdir -p "/run/archiso/curlspace"
+ mount -t tmpfs -o size="${curlspace_size}",mode=0755 curlspace "/run/archiso/curlspace"
+
+ # Check if URL ends in /
+ if [[ "${archiso_curl_url}" != "${archiso_curl_url%/}" ]]; then
+
+ local _aitab_url="${archiso_curl_url}${aitab#/run/archiso/bootmnt/}"
+ local _aitab_file="/run/archiso/curlspace/${aitab#/run/archiso/bootmnt/}"
+
+ _curl_get "${_aitab_url}" "${archisobasedir}"
+
+ local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
+ while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
+ [[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
+ [[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
+ if [[ "${aitab_fs_type}" != "none" ]]; then
+ if [[ "${aitab_sfs_comp}" != "none" ]]; then
+ _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "${archisobasedir}/${aitab_arch}"
+ else
+ _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.fs" "${archisobasedir}/${aitab_arch}"
+ fi
+ else
+ _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "${archisobasedir}/${aitab_arch}"
+ fi
+ done < "${_aitab_file}"
+
+ mkdir -p "/run/archiso/bootmnt"
+ mount -o bind /run/archiso/curlspace /run/archiso/bootmnt
+ else
+ local _dev_loop
+
+ _curl_get "${archiso_curl_url}" "/"
+
+ _dev_loop=$(losetup -f)
+ if ! losetup "${_dev_loop}" "/run/archiso/curlspace/${archiso_curl_url##*/}"; then
+ echo "ERROR: Setting loopback device '${_dev_loop}'"
+ echo " for file '/run/archiso/curlspace/${archiso_curl_url##*/}'"
+ echo " Falling back to interactive prompt"
+ echo " You can try to fix the problem manually, log out when you are finished"
+ launch_interactive_shell
+ fi
+ fi
+ archiso_mount_handler ${newroot}
+}
diff --git a/archiso/install/archiso_pxe_curl b/archiso/install/archiso_pxe_curl
new file mode 100644
index 0000000..a9342ae
--- /dev/null
+++ b/archiso/install/archiso_pxe_curl
@@ -0,0 +1,18 @@
+# vim: set ft=sh:
+
+build ()
+{
+ MODULES=""
+ BINARIES=""
+ FILES=""
+ SCRIPT="archiso_pxe_curl"
+
+ add_binary "/usr/bin/curl"
+}
+
+help ()
+{
+cat<<HELPEOF
+ This hook loads the necessary modules for boot via PXE and HTTP/FTP with curl.
+HELPEOF
+}
diff --git a/configs/releng/build.sh b/configs/releng/build.sh
index fcf5e4c..1c58a4e 100755
--- a/configs/releng/build.sh
+++ b/configs/releng/build.sh
@@ -16,7 +16,7 @@ script_path=$(readlink -f ${0%/*})
# Base installation (root-image)
make_basefs() {
mkarchiso ${verbose} -w "${work_dir}" -D "${install_dir}" -p "base" create
- mkarchiso ${verbose} -w "${work_dir}" -D "${install_dir}" -p "memtest86+ syslinux mkinitcpio-nfs-utils nbd" create
+ mkarchiso ${verbose} -w "${work_dir}" -D "${install_dir}" -p "memtest86+ syslinux mkinitcpio-nfs-utils nbd curl" create
}
# Additional packages (root-image)
@@ -28,7 +28,7 @@ make_packages() {
make_setup_mkinitcpio() {
if [[ ! -e ${work_dir}/build.${FUNCNAME} ]]; then
local _hook
- for _hook in archiso archiso_shutdown archiso_pxe_common archiso_pxe_nbd archiso_loop_mnt; do
+ for _hook in archiso archiso_shutdown archiso_pxe_common archiso_pxe_nbd archiso_pxe_curl archiso_loop_mnt; do
cp /lib/initcpio/hooks/${_hook} ${work_dir}/root-image/lib/initcpio/hooks
cp /lib/initcpio/install/${_hook} ${work_dir}/root-image/lib/initcpio/install
done
diff --git a/configs/releng/mkinitcpio.conf b/configs/releng/mkinitcpio.conf
index eb0a68a..6387982 100644
--- a/configs/releng/mkinitcpio.conf
+++ b/configs/releng/mkinitcpio.conf
@@ -1,2 +1,2 @@
-HOOKS="base udev memdisk archiso_shutdown archiso archiso_loop_mnt archiso_pxe_common archiso_pxe_nbd pata scsi sata virtio usb fw pcmcia filesystems usbinput"
+HOOKS="base udev memdisk archiso_shutdown archiso archiso_loop_mnt archiso_pxe_common archiso_pxe_nbd archiso_pxe_curl pata scsi sata virtio usb fw pcmcia filesystems usbinput"
COMPRESSION="xz"
diff --git a/configs/releng/packages.i686 b/configs/releng/packages.i686
index 7b66e41..1f5075f 100644
--- a/configs/releng/packages.i686
+++ b/configs/releng/packages.i686
@@ -2,7 +2,6 @@ aif
b43-fwcutter
btrfs-progs-unstable
crda
-curl
ddrescue
dhclient
dialog
diff --git a/configs/releng/packages.x86_64 b/configs/releng/packages.x86_64
index 7b66e41..1f5075f 100644
--- a/configs/releng/packages.x86_64
+++ b/configs/releng/packages.x86_64
@@ -2,7 +2,6 @@ aif
b43-fwcutter
btrfs-progs-unstable
crda
-curl
ddrescue
dhclient
dialog